#define STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PCKHDR_SIG	((short)0xAF1E)
#define CHIP_FNAME	"chip.a"
#define BITMAP_WIDTH	4096

char src_dir[_MAX_PATH];
char dst_dir[_MAX_PATH];
int back_color = 0x00FF00;

/***************************************************************************/

typedef struct _PCKHDR {
	short sig;	/* VOl` */
	short count;	/* vf     */
} PCKHDR;

typedef struct _PCKENT {
	char fname[24];	/* t@C */
	int length;	/* TCY     */
	int offset;	/* ItZbg */
} PCKENT;

typedef struct _TBLHDR {
	int count;	/* vf */
	char unk[28];	/* (s)  */
} TBLHDR;

typedef struct _BLKHDR {
	int w, h;	/* ubNTCY[sNZ] */
	int x, y;	/* ubN_  [sNZ] */
	int unkf;	/* (s:tH[}bg?) */
	int unkw;	/* (s:wƓ?)          */
	int unkh;	/* (s:hƓ?)          */
	int unk1;	/* (s)                   */
} BLKHDR;

/***************************************************************************/

class Image {
public:
	Image();
	virtual ~Image();
	void resize(int w, int h);
	int get(int x, int y) const;
	void set(int x, int y, int c);
	int w;		/*   [sNZ] */
	int h;		/* [sNZ] */
	int* bits;	/* J[obt@ */
};
Image::Image()
{
	this->w = 0;
	this->h = 0;
	this->bits = NULL;
}
Image::~Image()
{
	free(this->bits);
}
void
Image::resize(int w, int h)
{
	int x, y, *bits;

	bits = (int*)malloc(sizeof(int) * w * h);
	for(y = 0; y < h; y++) {
		for(x = 0; x < w; x++) {
			if(x < this->w && y < this->h) {
				bits[w * y + x] = this->bits[this->w * y + x];
			} else {
				bits[w * y + x] = back_color;
			}
		}
	}
	free(this->bits);
	this->w = w;
	this->h = h;
	this->bits = bits;
}
int
Image::get(int x, int y) const
{
	if(x < 0 || this->w <= x || y < 0 || this->h <= y) abort();
	return this->bits[this->w * y + x];
}
void
Image::set(int x, int y, int c)
{
	if(x < 0 || this->w <= x || y < 0 || this->h <= y) abort();
	this->bits[this->w * y + x] = c;
}

/***************************************************************************/

int proc1(const char* name, char* data);
int proc2(Image* img, char* data);
int blk32(Image* img, BLKHDR* bh);

int
main()
{
	int retval;
	int i, base, c;
	char path[_MAX_PATH];
	char* data;
	FILE *fp;
	PCKHDR ph;
	PCKENT* pe;

	/* o̓tH_擾܂B */
	printf("ύX̕Kv΁AReturnL[O񉟂łB\n");
	strcpy(src_dir, "c:\\program files\\leaf\\utaware");
	GetCurrentDirectory(sizeof dst_dir, dst_dir);
	printf("̂tH_[Default=%s]: ", src_dir);
	if(gets(path) != NULL && strlen(path) != 0) strcpy(src_dir, path);
	printf("摜t@CtH_[Default=%s]: ", dst_dir);
	if(gets(path) != NULL && strlen(path) != 0) strcpy(dst_dir, path);
	printf("wiF16i(rrggbb)Ŏw[Default=%06x]: ", back_color);
	if(gets(path) != NULL && sscanf(path, "%x", &c) == 1) back_color = c;

	/* ̓t@CJ܂B */
	_makepath(path, NULL, src_dir, CHIP_FNAME, NULL);
	fp = fopen(path, "rb");
	if(fp == NULL) abort();

	/* pbNwb_擾B */
	retval = fread(&ph, sizeof(ph), 1, fp);
	if(retval != 1) abort();
	if(ph.sig != PCKHDR_SIG) abort();

	/* pbNe[u擾B */
	pe = (PCKENT*)malloc(sizeof(PCKENT) * ph.count);
	retval = fread(pe, sizeof(PCKENT), ph.count, fp);
	if(retval != ph.count) abort();

	/* evfɂ... */
	base = sizeof(PCKHDR) + sizeof(PCKENT) * ph.count;
	for(i = 0; i < ph.count; i++) {
		printf("%3d/%3d: %s ", i + 1, ph.count, pe[i].fname);

		/* f[^ǂݍ݁B */
		retval = fseek(fp, base + pe[i].offset, SEEK_SET);
		if(retval != 0) abort();
		data = (char*)malloc(pe[i].length);
		retval = fread(data, 1, pe[i].length, fp);
		if(retval != pe[i].length) abort();

		/* C[W쐬B */
		retval = proc1(pe[i].fname, data);
		printf(retval == 0 ? "OK" : "###SKIP###");

		free(data);
		printf("\n");
	}

	/* pbNe[uJB */
	free(pe);

	return 0;
}

/***************************************************************************/

int
proc1(const char* name, char* data)
{
	int retval;
	char path[_MAX_PATH];
	char fname[_MAX_FNAME];
	FILE* fp;
	BITMAPFILEHEADER bf;
	BITMAPINFOHEADER bi;
	TBLHDR* th;
	int i, base, ofs, line_bytes, x, y, c, w, h, x0, y0;
	int* td;
	char *line;

	Image img;

	/* Ήt@COB */
	if(strncmp(name, "falc0m", 6) == 0) return -1; /* `݁H */

	/* 1x32rbg */
	if(strncmp(name, "ci_", 3) == 0) {
		if(strcmp(name, "ci_rob.px") == 0) return -1; /* ɕʌ`H */
		retval = proc2(&img, data);
		if(retval != 0) return -1;

	/* 2x32rbg */
	} else if(strcmp(name, "kib.px") == 0 || strcmp(name, "߶۸.px") == 0) {
		/* e[uwb_擾B */
		th = (TBLHDR*)(data + 0);
		td = (int*)(data + sizeof(TBLHDR));

		/* evfɂ... */
		base = sizeof(TBLHDR) + sizeof(int) * th->count;
		x0 = 0;
		y0 = 0;
		for(i = 0; i < th->count; i++) {
			Image blk;

			ofs = td[i];
			retval = proc2(&blk, data + base + ofs);
			if(retval != 0) return -1;

			/* `bv܂Ƃ߂đgݍ݂܂B */
			if(x0 >= BITMAP_WIDTH) {
				x0 = 0;
				y0 = img.h;
			}
			if((w = x0 + blk.w) < img.w) w = img.w;
			if((h = y0 + blk.h) < img.h) h = img.h;
			if(w > img.w || h > img.h) img.resize(w, h);
			for(y = 0; y < blk.h; y++) {
				for(x = 0; x < blk.w; x++) {
					c = blk.get(x, y);
					img.set(x0 + x, y0 + y, c);
				}
			}
			x0 += blk.w;
		}
	} else {
		return -1;
	}

	/* rbg}bvۑB */
	_splitpath(name, NULL, NULL, fname, NULL);
	_makepath(path, NULL, dst_dir, fname, ".bmp");
	fp = fopen(path, "wb");
	if(fp == NULL) abort();
	line_bytes = (3 * img.w) + 3 & ~3;
	line = (char*)calloc(line_bytes, 1);
	memset(&bf, 0, sizeof bf);
	bf.bfType = 'MB';
	bf.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + line_bytes * img.h;
	bf.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	retval = fwrite(&bf, sizeof bf, 1, fp);
	if(retval != 1) abort();
	memset(&bi, 0, sizeof bi);
	bi.biSize = sizeof bi;
	bi.biWidth = img.w;
	bi.biHeight = img.h;
	bi.biPlanes = 1;
	bi.biBitCount = 24;
	retval = fwrite(&bi, sizeof bi, 1, fp);
	if(retval != 1) abort();
	for(y = img.h - 1; y >= 0; y--) {
		for(x = 0; x < img.w; x++) {
			c = img.get(x, y);
			memcpy(line + 3 * x, &c, 3);
		}
		retval = fwrite(line, 1, line_bytes, fp);
	}
	free(line);
	fclose(fp);

	return 0;
}

/***************************************************************************/

int
proc2(Image* img, char* data)
{
	int retval;
	int i, base, ofs;
	TBLHDR* th;
	BLKHDR* bh;
	int* td;

	/* e[uwb_擾B */
	th = (TBLHDR*)(data + 0);
	td = (int*)(data + sizeof(TBLHDR));

	/* evfɂ... */
	base = sizeof(TBLHDR) + sizeof(int) * th->count;
	for(i = 0; i < th->count; i++) {
		ofs = td[i];

		bh = (BLKHDR*)(data + base + ofs);
		retval = blk32(img, bh);
		if(retval != 0) abort();
	}

	return 0;
}

/***************************************************************************/

int
blk32(Image* img, BLKHDR* bh)
{
	Image blk;
	int j, run, n, x, y, c, w, h;
	int* p;

	if(bh->unkf != 0x00200004) abort();

	blk.resize(bh->w, bh->h);
	p = (int*)(bh + 1);

	/*{{šʂłBłs\B */
	run = 0;
	x = 0;
	y = 0;
	for(;;) {
		n = *p++;
		if(n == 0xFFFFFFFE) {
			run = !run;
			continue;
		} else if(n == 0xFFFFFFFF) {
			break;
		}

		n = *p;
		n = n >> 16 & 0xFFFF;
		if(n >= 0x10000 - bh->w) {
			n -= 0x10000 - bh->w;
			n += ((*p & 0xFF) - 1) * bh->w;
		} else {
			n += (*p & 0xFF) * bh->w;
		}
		while(n-- != 0) {
			if(++x == bh->w) {
				x = 0;
				y++;
			}
		}
		p++;

		n = *p++;
		if(n < 1 || bh->w < n) abort();
		for(j = 0; j < n; j++) {
			c = *p++;
			blk.set(x++, y, c);
			if(x == bh->w) {
				x = 0;
				y++;
			}
		}
	}
	/*}}šʂłBłs\B */

	/* ubNS̃C[Wɑgݍ݂܂B */
	if((w = bh->x + bh->w) < img->w) w = img->w;
	if((h = bh->y + bh->h) < img->h) h = img->h;
	if(w > img->w || h > img->h) img->resize(w, h);
	for(y = 0; y < bh->h; y++) {
		for(x = 0; x < bh->w; x++) {
			c = blk.get(x, y);
			img->set(bh->x + x, bh->y + y, c);
		}
	}

	return 0;
}
